//+------------------------------------------------------------------+
//|                                           HA T3-1 EA Scanner.mq4 |
//|                    Copyright  2010, Varun Juneja aka OneFineDay |
//|                                   http://www.myforexjourney.co.cc|
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Varun Juneja"
#property link      "http://www.myforexjourney.co.cc"

extern string     ReleaseDate                   = "--- May 13, 2010 12:30 GMT --- ";
extern string     AlertSettings                 = "-------------Alert Settings----------";
extern int        TrendDirectionTimeFrame       = 240;
extern int        SignalTimeFrame               = 30;
extern bool       SendEmail                     = false;
extern bool       DisplayAlert                  = true;
       bool       Debug                         = false; // <-- externally enable only for bug testing
extern bool       OnScreenMessages              = true;
extern string     PairSelection = "-------------Pair Selection----------";
extern int        SpreadLessThanOREqualTo       = 12;
extern string     DefaultPairsList              = "AUDCAD,AUDCHF,AUDJPY,AUDNZD,AUDUSD,CADCHF,CADJPY,CHFJPY,EURAUD,EURCAD,EURCHF,EURGBP,EURJPY,EURNZD,EURUSD,GBPAUD,GBPCAD,GBPCHF,GBPJPY,GBPNZD,GBPUSD,NZDCAD,NZDCHF,NZDJPY,NZDUSD,USDCAD,USDCHF,USDJPY";
//extern string     DefaultPairsList              = "EURUSD,GBPUSD,USDJPY,USDCHF,USDCAD,AUDUSD,NZDAUD";
extern bool       OnlyScanTonysPairs            = false; //<-- needs to be bugtested and enabled. Currently not displayed externally and disabled  9/6 Fixed CapeCoddah
extern string     AddOn= "-------------AddOn Signal----------";
extern bool       AddOnSignalConfirmation = true;
extern int        CheckForAddOnEveryXMins = 10;
extern int        PositiveMoveInPips = 25;
extern string     CandleClose = "--------Signal on Tick/Candle Close------";
extern bool       WaitForTradingTFCandleClose = false;
extern bool       WaitForSignalTFCandleClose = true;
extern string     SignalConfirmation = "-------Extra Signal Confirmation-------";
extern bool       CheckForTrendLordOnTDTF = true;
extern bool       TrendLordPrevColorCheck = true;
extern int        TrendLordPrevColorCheckBars = 5;
extern bool       CheckForAOOnSignalDirectionTF = false;
extern bool       AOColorConfirmation = true;
extern bool       TDTFMACrossOverConfrimation = false;
extern string     MiscSettings = "-------------Misc Settings----------";
extern int        TrendTFCozyNess = 4;
extern int        CheckAccHistoryEveryXMins = 15;
extern bool       ScanRunMessages = false;
extern int        RunTDTFScanEveryXMins = 5;
extern string     FontSettings = "-------------Font and Colours---------";
extern string     Font="Arial Black";
extern int        FontSize=7;
extern color      MainColor=Black;
extern color      LongColor=Blue;
extern color      OldLongColor=Blue;
extern color      ShortColor=Red;
extern color      OldShortColor=Red;
extern color      WaitingColor=Lime;
extern color      NoDirectionColor=Yellow;
extern int        ivertical=1;
extern double     vertical_inc=1.2; 
extern int        horizontal=1; 
extern int        horizontal_inc=90;

   #define BUY 4
   #define SELL 5
   #define RED 6
   #define BLUE 7

   #define GOSHORT 2
   #define GOLONG 1
   #define NODIRECTION 0
   #define CONFIRMINGBUY 3
   #define CONFIRMINGSELL 4
   
   #define  NL    "\n"

int TTFTime, STFTime, spread, LookBackOnSignal, hfbarsback, TrendTFBackCheck, FuncLastRunTime, FuncLastRunTime2,addon, pairset, scanmax, LookBackOnTTF, tempvar, TTFTime2;
double ask, bid, point, SL, AO_Curr, AO_Prev;
string digits, screencomments, tpsl;
int HigherTimeFrameSignal[28]; 
int LowerTimeFrameSignal[];
int SetAlertFlagBuy[28];
int SetAlertFlagSell[28];
int AlertTimeLTF[28];

int temp1,temp2,temp3;
int vertical;
string pair[30];
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+

int Set_Pairs(string PairsList)               //9/6 CapeCoddah
   {
   string thepair;
   int i, len, pos = StringFind(PairsList,",",0);
   for(i=0;i<30;i++) pair[i]="";
   
   i=0;
   while(pos>0)   
      {
      thepair=StringSubstr(PairsList,0,pos);   
      len=StringLen(PairsList);
      len=len-pos;
      pair[i]=StringTrimLeft(StringTrimRight(thepair));
      PairsList=StringSubstr(PairsList,pos+1,len);
      
      pos = StringFind(PairsList,",",0);
      i++;
      if(i>=30) 
         {
         Alert("Too Many Currency Pairs specified in Default Pairs List, Maximum 30");
         return(-1);
         }
     }
   if(len>0) pair[i]=PairsList;        //to catch the last pair in list
   return(i+1);
   }      
      
int init()
  {
//----
   if(WaitForSignalTFCandleClose) LookBackOnSignal = 1; else LookBackOnSignal = 0;
   if(WaitForTradingTFCandleClose) LookBackOnTTF = 1; else LookBackOnTTF = 0;
   if(AddOnSignalConfirmation) addon = 1; else addon = 0;
      
   if(OnlyScanTonysPairs == true) {                                                    //CapeCoddah 9/6
      pairset = 2;
      scanmax=Set_Pairs("EURJPY,GBPJPY,EURUSD,USDJPY,GBPUSD,USDCHF,AUDUSD,USDCAD,NZDUSD,CHFJPY,AUDJPY,NZDJPY,EURCAD,GBPCAD");
      SpreadLessThanOREqualTo = 100;
      } else {
      pairset = 1;
      scanmax=Set_Pairs(DefaultPairsList);
      }
   //if(scanmax<1) return(-1);           //error, kill run
   
   FuncLastRunTime = TimeCurrent();
   FuncLastRunTime2 = TimeCurrent();
   
   // Changed EURUSD to Symbol() - fxdrive - 10/05/2010
   temp1 = MarketInfo(Symbol() ,MODE_DIGITS);
   
   if(temp1 == 5 || temp1 == 3)
   {
   SpreadLessThanOREqualTo = SpreadLessThanOREqualTo*10;
   }
   
     
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectsDeleteAll(0, OBJ_LABEL); //CapeCoddah 9/6
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
    //horizontal=ihorizontal;                            9/6 CapeCoddah
    vertical=ivertical;
     ObjectsDeleteAll(0, OBJ_LABEL);
    //if(pairset == 1) string pair[28]= {"AUDCAD","AUDCHF","AUDJPY","AUDNZD","AUDUSD","CADCHF","CADJPY","CHFJPY","EURAUD","EURCAD","EURCHF","EURGBP","EURJPY","EURNZD","EURUSD","GBPAUD","GBPCAD","GBPCHF","GBPJPY","GBPNZD","GBPUSD","NZDCAD","NZDCHF","NZDJPY","NZDUSD","USDCAD","USDCHF","USDJPY"};    //CapeCoddah 9/6
    //if(pairset == 2) pair[14]= {"EURJPY","GBPJPY","EURUSD","USDJPY","GBPUSD","USDCHF","AUDUSD","USDCAD","NZDUSD","CHFJPY","AUDJPY","NZDJPY","EURCAD","GBPCAD"};
    //if(pairset == 3) pair[6]= {"EURUSD","GBPUSD","USDJPY","USDCHF","USDCAD","AUDUSD"};
    // Add Symbol Suffix to pair array - fxdrive - 10/05/2010
    string SymbolSuffix = StringSubstr(Symbol(),6,4);
    int pair_size=ArraySize(pair);
    for (int i=0; i<pair_size;, i++)
    {
      pair[i]=StringConcatenate(pair[i],SymbolSuffix);
    }
    
    CheckAccountHistory(CheckAccHistoryEveryXMins);
    AddOnPosition(CheckForAddOnEveryXMins,addon);
    
if(TTFTime < Time[0] || !WaitForTradingTFCandleClose) {
TTFTime = Time[0];
   
   //if(OnScreenMessages) screencomments = StringConcatenate("HA T3-1 System Scanner Enabled",NL,"Currently tested only for 30M and 4H Time Frames",NL,NL,NL,"Trend Direction TimeFrame = ",TrendDirectionTimeFrame/60,"H",NL,"Signal TimeFrame = ",SignalTimeFrame,"M",NL,NL,NL);
   //if(OnScreenMessages) ScreenComment(screencomments, true);
      if(OnScreenMessages) {
      Printtxt("HA T3-1 System Scanner Enabled", "H1", FontSize, Font, MainColor, vertical, horizontal);vertical = vertical+vertical_inc;
      Printtxt("Currently tested only for 30M and 4H Time Frames", "H2", FontSize, Font, MainColor, vertical, horizontal);vertical = vertical+vertical_inc;      
      Printtxt("Trend Direction TimeFrame = " + TrendDirectionTimeFrame/60 + "H", "H3", FontSize, Font, MainColor, vertical, horizontal);vertical = vertical+vertical_inc;            
      Printtxt("Signal TimeFrame = " + SignalTimeFrame + "M", "H4", FontSize, Font, MainColor, vertical, horizontal);vertical = vertical+vertical_inc+vertical_inc;                  
   }
   
   int a = 0;
   for(int j=0; j<scanmax; j++) {
      
      RefreshRates();
      ask = MarketInfo(pair[j],MODE_ASK);
      bid = MarketInfo(pair[j],MODE_BID);
      point = MarketInfo(pair[j],MODE_POINT);
      digits = MarketInfo(pair[j],MODE_DIGITS);
      spread = MarketInfo(pair[j],MODE_SPREAD);
      
      if(SpreadLessThanOREqualTo >= spread)
      {
         a += 1; // for counting no of pairs passed
                    
         //if(STFTime - TrendDirectionTimeFrame*60 < Time[0]) // VJ to be rectified & tested
         //{
            //STFTime = Time[0];
                        
            if(SignalCheck(pair[j],TrendDirectionTimeFrame,LookBackOnTTF,true) == GOLONG)
            {
               HigherTimeFrameSignal[j] = GOLONG;
               if(Debug) Alert("ID:786 :: ",pair[j]," = ",HigherTimeFrameSignal[j]," & symbol id j = ",j);
               if(hfbarsback <= TrendTFCozyNess && HigherTimeFrameSignal[j] == GOLONG)
               {
                  if(AlertTimeLTF[j] == 0)
                  {
                    AlertTimeLTF[j] = 1;
                     if(SendEmail) SendMail(pair[j]+" TTF","["+pair[j]+"] has given BUY on "+TrendDirectionTimeFrame/60+"H Time Frame; "+hfbarsback+" bars back.");
                     if(DisplayAlert) Alert(pair[j]+" TTF :: ["+pair[j]+"] has given BUY on "+TrendDirectionTimeFrame/60+"H Time Frame; "+hfbarsback+" bars back.");
                  }
                  if(Debug) Alert("NEW LONG :: ",pair[j]," ",hfbarsback);
                  SL = bid-((30+spread)*point);
                  //if(OnScreenMessages) screencomments = StringConcatenate(pair[j]," = LONG SIGNAL CONFIRMED <---------- (",hfbarsback," BARS BACK) || Place SL at ",SL,NL,NL);
                  if(OnScreenMessages) Printtxt(pair[j] + " = LONG Signal" + hfbarsback + " BARS BACK. Place SL at "+SL,"A"+j, FontSize, Font, LongColor, vertical, horizontal);vertical = vertical+vertical_inc;                                    
               } else {
                  if(hfbarsback > TrendTFCozyNess && HigherTimeFrameSignal[j] == GOLONG)
                  {
                     if(Debug) Alert("OLD LONG :: ",pair[j]," ",hfbarsback);
                     // tempvar = hfbarsback + TrendTFCozyNess; <-- redundant
                     //if(OnScreenMessages) screencomments = StringConcatenate(pair[j]," = Old Long Signal (was displayed ",hfbarsback," bars back)",NL,NL);
                     if(OnScreenMessages) Printtxt(pair[j] + " = Old Long Signal displayed " + hfbarsback + " bars back)", "A"+j, FontSize, Font, OldLongColor, vertical, horizontal);vertical = vertical+vertical_inc;                                       
                  }
               }
            }
                        
            if(SignalCheck(pair[j],TrendDirectionTimeFrame,LookBackOnTTF,true) == GOSHORT)
            {
               HigherTimeFrameSignal[j] = GOSHORT;
               if(Debug) Alert("ID:787 :: ",pair[j]," = ",HigherTimeFrameSignal[j]," & symbol id j = ",j);
               if(hfbarsback <= TrendTFCozyNess && HigherTimeFrameSignal[j] == GOSHORT)
               {
                  if(AlertTimeLTF[j] == 0)
                  {
                    AlertTimeLTF[j] = 1;
                     if(SendEmail) SendMail(pair[j]+" TTF","["+pair[j]+"] has given SELL on "+TrendDirectionTimeFrame/60+"H Time Frame; "+hfbarsback+" bars back.");
                     if(DisplayAlert) Alert(pair[j]+" TTF :: ["+pair[j]+"] has given SELL on "+TrendDirectionTimeFrame/60+"H Time Frame; "+hfbarsback+" bars back.");
                  }
                  if(Debug) Alert("NEW SHORT :: ",pair[j]," ",hfbarsback);
                  SL = ask+((30+spread)*point);
                  //if(OnScreenMessages) screencomments = StringConcatenate(pair[j]," = SHORT SIGNAL COFIRMED <---------- (",hfbarsback," BARS BACK) || Place SL at ",SL,NL,NL);
                  if(OnScreenMessages) Printtxt(pair[j] + " = SHORT SIGNAL " + hfbarsback + " BARS BACK. Place SL at "+SL, "A"+j, FontSize, Font, ShortColor, vertical, horizontal);vertical = vertical+vertical_inc;                                                                           
               } else {
                  if(hfbarsback > TrendTFCozyNess && HigherTimeFrameSignal[j] == GOSHORT)
                  {
                     if(Debug) Alert("OLD SHORT :: ",pair[j]," ",hfbarsback);
                     //tempvar = hfbarsback + TrendTFCozyNess; <-- redundant
                     //if(OnScreenMessages) screencomments = StringConcatenate(pair[j]," = Old Short Signal (was displayed ",hfbarsback," bars back)",NL,NL);
                     if(OnScreenMessages) Printtxt(pair[j] + " = Old Short Signal displayed " + hfbarsback + " bars back)", "A"+j , FontSize, Font, OldShortColor, vertical, horizontal);vertical = vertical+vertical_inc;                                                                                                   
                  }
               }
            }
            
            if(SignalCheck(pair[j],TrendDirectionTimeFrame,LookBackOnTTF,true) == CONFIRMINGBUY)
            {
               AlertTimeLTF[j] = 0;
               //if(OnScreenMessages) screencomments = StringConcatenate(pair[j]," = Waiting for Buy Confirmation (HA Signal received ",hfbarsback," bars back, AO/TrendLord disagreeing)",NL);
               if(OnScreenMessages) Printtxt(pair[j] + " = Waiting for Buy (HA " + hfbarsback + " bars back, AO/TL disagreeing)", "A"+j, FontSize, Font, WaitingColor, vertical, horizontal);vertical = vertical+vertical_inc;                                                                                             
            }
            
            if(SignalCheck(pair[j],TrendDirectionTimeFrame,LookBackOnTTF,true) == CONFIRMINGSELL)
            {
               AlertTimeLTF[j] = 0;
               //if(OnScreenMessages) screencomments = StringConcatenate(pair[j]," = Waiting for Sell Confirmation (HA Signal received ",hfbarsback," bars back, AO/TrendLord disagreeing)",NL);
               if(OnScreenMessages) Printtxt(pair[j] + " = Waiting for Sell (HA " + hfbarsback + " bars back, AO/TL disagreeing)", "A"+j, FontSize, Font, WaitingColor, vertical, horizontal);vertical = vertical+vertical_inc;                                                                                             
            }
            
            if(SignalCheck(pair[j],TrendDirectionTimeFrame,LookBackOnTTF,true) == NODIRECTION)
            {
               AlertTimeLTF[j] = 0;
               //if(OnScreenMessages) screencomments = StringConcatenate(pair[j]," = No Direction (Waited for confirmation after signal for ",TrendTFCozyNess," bars)",NL);
               if(OnScreenMessages) Printtxt(pair[j] + " = No Direction (Waited for " + TrendTFCozyNess + " bars)", "A"+j, FontSize, Font, NoDirectionColor, vertical, horizontal);vertical = vertical+vertical_inc;                                                                                             
              
            }
                       
          //}//if(STFTime - TrendDirectionTimeFrame*60 < Time[0])
  
  if(TTFTime2 < Time[0] || !WaitForSignalTFCandleClose) {
     TTFTime2 = Time[0];
  
         if(HigherTimeFrameSignal[j] == GOLONG && SignalCheck(pair[j],SignalTimeFrame,LookBackOnSignal,false) == BUY && CCI(pair[j],SignalTimeFrame,LookBackOnSignal) == BLUE && (!CheckForAOOnSignalDirectionTF || AO(pair[j],SignalTimeFrame,LookBackOnSignal,0) > 0))
         {
              if(SetAlertFlagBuy[j] == 0)
              {
                  SetAlertFlagBuy[j] = 1;
                  if(SendEmail) SendMail(pair[j]+" BUY","["+pair[j]+"] gave a buy signal at "+DoubleToStr(ask,digits)+" on the "+SignalTimeFrame+"M Time Frame.");
                  if(DisplayAlert) Alert(pair[j]+" BUY :: ["+pair[j]+"] gave a buy signal at "+DoubleToStr(ask,digits)+" on the "+SignalTimeFrame+"M Time Frame.");
              }
         } else {
            SetAlertFlagBuy[j] = 0;
         }
         
         if(HigherTimeFrameSignal[j] == GOSHORT && SignalCheck(pair[j],SignalTimeFrame,LookBackOnSignal,false) == SELL && CCI(pair[j],SignalTimeFrame,LookBackOnSignal) == RED && (!CheckForAOOnSignalDirectionTF || AO(pair[j],SignalTimeFrame,LookBackOnSignal,0) < 0))
         {
            if(SetAlertFlagSell[j] == 0)
              {
                  SetAlertFlagSell[j] = 1;
                  if(SendEmail) SendMail(pair[j]+" SELL","["+pair[j]+"] gave a sell signal at "+DoubleToStr(ask,digits)+" on the "+SignalTimeFrame+"M Time Frame.");
                  if(DisplayAlert) Alert(pair[j]+" SELL :: ["+pair[j]+"] gave a sell signal at "+DoubleToStr(ask,digits)+" on the "+SignalTimeFrame+"M Time Frame.");
               }
         } else {
            SetAlertFlagSell[j] = 0;
         }

  }

         //if(OnScreenMessages) ScreenComment(screencomments, false);
         
     }// if(SpreadLessThanOREqualTo =< spread)
      
  } //for(int j=0; j<28; j++) {
  
  if(pairset == 1) {                                                                                     
  if(SendEmail && ScanRunMessages) SendMail("HAT3-Gen","Completed Scan of "+a+" pairs with Spread <= "+SpreadLessThanOREqualTo+". All NEW opportunities, if any reported.");
  if(DisplayAlert && ScanRunMessages) Alert("HAT3-Gen :: Completed Scan of ",a," pairs with Spread <= ",SpreadLessThanOREqualTo,". All NEW opportunities, if any reported.");
  }
  
  if(pairset == 2) {
  if(SendEmail && ScanRunMessages) SendMail("HAT3-Gen","Completed Scan of "+a+" pairs, which Tony uses. All NEW opportunities, if any reported.");
  if(DisplayAlert && ScanRunMessages) Alert("HAT3-Gen :: Completed Scan of ",a," pairs, which Tony uses. All NEW opportunities, if any reported.");
  }
  
}// if(TTFTime < Time[0] || !WaitForTradingTFCandleClose)
   Sleep(RunTDTFScanEveryXMins*60*1000);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//--- Function which check the Arrows which are formed on the HA
//--- Symbol, TimeFrame is Self Explanatory
//--- LookBack is x bars back in time you want to look for the signal
//--- OverRide helps in going back and figuring out direction on the 4H
//+------------------------------------------------------------------+
int SignalCheck(string symbol, int timeframe, int lookback, bool OverRide)
{
   
   if(OverRide == false) {
   double arrowup = iCustom(symbol,timeframe,"Heiken_Ashi_Ma_T3-1",4,lookback);
   double arrowdown = iCustom(symbol,timeframe,"Heiken_Ashi_Ma_T3-1",5,lookback);
   
   if(arrowup == EMPTY_VALUE)
   {
      arrowup = 0;
   } else {
      if(arrowup > 0)
      {
         return(BUY);
      }// if(arrowup > 0)
   }//  else
   
   if(arrowdown == EMPTY_VALUE)
   {
      arrowdown = 0;
   } else {
      if(arrowdown > 0)
      {
         return(SELL);
      }// if(arrowup > 0)
   }//  else
   } // if(OverRide = false)
   
   if(OverRide == true) {
   
      for(int j=200;j>0;j--)
      {
         if(WaitForTradingTFCandleClose) hfbarsback = 201-j;
         if(!WaitForTradingTFCandleClose) hfbarsback = 200-j;
         
         arrowup = iCustom(symbol,timeframe,"Heiken_Ashi_Ma_T3-1",4,hfbarsback);
         arrowdown = iCustom(symbol,timeframe,"Heiken_Ashi_Ma_T3-1",5,hfbarsback);
         
            if(arrowdown < 5000 || arrowup < 5000)
            {
            j=0;
            
            if(TrendTFCozyNess >= hfbarsback) TrendTFBackCheck = 0;
            if(TrendTFCozyNess < hfbarsback) TrendTFBackCheck = hfbarsback - TrendTFCozyNess;
            
            double SMA3 = iMA(symbol,TrendDirectionTimeFrame,3,0,0,0,TrendTFBackCheck);
            double SMA5 = iMA(symbol,TrendDirectionTimeFrame,5,1,0,0,TrendTFBackCheck);
            
            if(Debug) Alert("SignalCheck Function Call variable TrendTFCozyNess :: ",symbol," = ",TrendTFBackCheck);
            
               if(arrowup < 5000) 
               {
                  AO_Curr = AO(symbol,TrendDirectionTimeFrame,TrendTFBackCheck,0);
                  AO_Prev = AO(symbol,TrendDirectionTimeFrame,TrendTFBackCheck,1);
                  if(AO_Curr > 0 && (AO_Curr > AO_Prev || !AOColorConfirmation) && (SMA3 > SMA5 || !TDTFMACrossOverConfrimation) && (TrendLord(symbol,TrendDirectionTimeFrame,TrendTFBackCheck) == BLUE || !CheckForTrendLordOnTDTF))
                  { 
                   return(GOLONG);
                  } else {
                     if(hfbarsback <= TrendTFCozyNess)
                     {
                        return(CONFIRMINGBUY);
                     } else {
                        return(NODIRECTION);
                     }
                  }
               }// if(arrowup < 5000) 
               
               if(arrowdown < 5000) 
               {
                  AO_Curr = AO(symbol,TrendDirectionTimeFrame,TrendTFBackCheck,0);
                  AO_Prev = AO(symbol,TrendDirectionTimeFrame,TrendTFBackCheck,1);
                  if(AO_Curr < 0 && (AO_Curr < AO_Prev || !AOColorConfirmation) &&(SMA3 < SMA5 || !TDTFMACrossOverConfrimation) && (TrendLord(symbol,TrendDirectionTimeFrame,TrendTFBackCheck) == RED || !CheckForTrendLordOnTDTF))
                  { 
                   return(GOSHORT);
                  } else {
                     if(hfbarsback <= TrendTFCozyNess)
                     {
                        return(CONFIRMINGSELL);
                     } else {
                        return(NODIRECTION);
                     }
                  }
               }// if(arrowdown < 5000) 
               
            }// if(arrowdown < 5000 || arrowup < 5000)

		}//for(int j=200;j>0;j--)
	
	}//if(OverRide = true)
   

} // int SignalCheck(string symbol, int timeframe, int lookback)

//+------------------------------------------------------------------+
//--- Function to Check the value of the AO
//--- Symbol, TimeFrame is Self Explanatory
//--- LookBack is x bars back in time you want to look for the signal
//--- Mode spits out either the Current bar AO(0) or Prev Bar AO(1)
//+------------------------------------------------------------------+
double AO(string symbol, int timeframe, int lookback, int mode)
{
   double AO_Val;
   if(mode == 0) AO_Val = iMA(symbol,timeframe,5,0,MODE_SMA,PRICE_MEDIAN,lookback)-iMA(symbol,timeframe,34,0,MODE_SMA,PRICE_MEDIAN,lookback);
   if(mode == 1) AO_Val = iMA(symbol,timeframe,5,0,MODE_SMA,PRICE_MEDIAN,lookback+1)-iMA(symbol,timeframe,34,0,MODE_SMA,PRICE_MEDIAN,lookback+1);
   return(AO_Val);
}

//+------------------------------------------------------------------+
//--- Function to Check the value of the TrendLord
//--- Symbol, TimeFrame is Self Explanatory
//--- LookBack is x bars back in time you want to look for the signal
//+------------------------------------------------------------------+
int TrendLord(string symbol, int timeframe, int lookback)
{
   double TrendLordBlue = iCustom(symbol,timeframe,"TrendLord",1,lookback);
   double TrendLordRed = iCustom(symbol,timeframe,"TrendLord",2,lookback);
   
   double TrendLordBlue_Prev = iCustom(symbol,timeframe,"TrendLord",1,lookback+TrendLordPrevColorCheckBars);
   double TrendLordRed_Prev = iCustom(symbol,timeframe,"TrendLord",2,lookback+TrendLordPrevColorCheckBars);
   
   if(TrendLordBlue < 5000)
   {
      if(!TrendLordPrevColorCheck || TrendLordRed_Prev < 5000)
      {
         return(BLUE);
      }      
   }
   
   if(TrendLordRed < 5000)
   {
      if(!TrendLordPrevColorCheck || TrendLordBlue_Prev < 5000)
      {
         return(RED);
      } 
   }
   
}// double TrendLord(string symbol, int timeframe, int lookback)

//+------------------------------------------------------------------+
//--- Function to Check the value of the CCI
//--- Symbol, TimeFrame is Self Explanatory
//--- LookBack is x bars back in time you want to look for the signal
//+------------------------------------------------------------------+
int CCI(string symbol, int timeframe, int lookback)
{
   double CCIBlue = iCustom(symbol,timeframe,"W-LNX",6,lookback);
   double CCIRed = iCustom(symbol,timeframe,"W-LNX",7,lookback);
   
   if(CCIBlue < 5000)
   {
      return(BLUE);
   }
   
   if(CCIRed < 5000)
   {
      return(RED);
   }
   
}
//+------------------------------------------------------------------+
//--- Function to Write Comments on the Screen
//--- Text is the text that you want to pass
//--- ResetText is used when we have to reset the comments on the screen
//+------------------------------------------------------------------+
void ScreenComment(string Text, bool ResetText)
{
   static string ExistingComment = "";
   if (ResetText) ExistingComment = "";
   ExistingComment = ExistingComment + Text;
   Comment(ExistingComment);
}
//+------------------------------------------------------------------+
//--- Function to Check Account History for closed trades for 
//--- shooting alerts.
//--- TimeElapsed: It only lists the orders closed within x mins
//+------------------------------------------------------------------+
void CheckAccountHistory(int TimeElapsed)
{
   if(FuncLastRunTime + (TimeElapsed*60) < TimeCurrent())
   {
      for(int cnt = OrdersHistoryTotal(); cnt > 0; cnt--)
      {
         if(!OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY)) continue;
         {       
            if(OrderCloseTime() > FuncLastRunTime)
            {
              if(OrderClosePrice() == OrderTakeProfit()) tpsl = "Take Profit Value";
              if(OrderClosePrice() == OrderStopLoss()) tpsl = "Stop Loss Value";
              if(OrderClosePrice() != OrderStopLoss() && OrderClosePrice() != OrderTakeProfit()) tpsl = "price, you closed it manually";
              if(SendEmail) SendMail(OrderSymbol()+" Closed",OrderSymbol()+" just hit your mentioned "+tpsl+" and netted $"+DoubleToStr(OrderProfit(),2)+".");
              if(DisplayAlert) Alert(OrderSymbol()+" Closed :: "+OrderSymbol()+" just hit your mentioned "+tpsl+" and netted $"+DoubleToStr(OrderProfit(),2)+".");
            }
         } //if(!OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY)) continue;
      } // for(int cnt = 0; cnt < OrdersHistoryTotal(); cnt++)
   FuncLastRunTime = TimeCurrent();
   }// if(FuncLastRunTime + (TimeElapsed*60) < TimeLocal())
}
//+------------------------------------------------------------------+
//--- Function to for alerts for add on positions
//--- Time is the time it checks for them every x mins
//--- BarCount means it will check for signals x bars previously
//+------------------------------------------------------------------+
void AddOnPosition(int TimeToCheck, int BarCount)
{
   if(FuncLastRunTime2 + (TimeToCheck*60) < TimeCurrent())
   {
    if(Debug) Alert("Loop 1 Clear");
      for(int cnt = 0; cnt < OrdersTotal(); cnt++)
      {
       if(Debug) Alert("Loop 2 Clear");  
         if(!OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES)) continue;
         {
           if(Debug) Alert("Loop 3 Clear");  
             if(OrderTakeProfit() > PositiveMoveInPips)
             {
              if(Debug) Alert("Loop 4 Clear"); 
               if(SignalCheck(OrderSymbol(),SignalTimeFrame,BarCount,false) == BUY && CCI(OrderSymbol(),SignalTimeFrame,BarCount) == BLUE && AO(OrderSymbol(),SignalTimeFrame,BarCount,0) > 0)
               {
                 if(Debug) Alert("Loop 5.1 Clear"); 
                  if(SendEmail) SendMail(OrderSymbol()+"Add-On",OrderSymbol()+" has given an add-on BUY signal for an existing position.");
                  if(DisplayAlert) Alert(OrderSymbol()+"Add-On :: "+OrderSymbol()+" has given an add-on BUY signal for an existing position.");
               }
               
               if(SignalCheck(OrderSymbol(),SignalTimeFrame,BarCount,false) == SELL && CCI(OrderSymbol(),SignalTimeFrame,BarCount) == RED && AO(OrderSymbol(),SignalTimeFrame,BarCount,0) < 0)
               {
                 if(Debug) Alert("Loop 5.2 Clear"); 
                  if(SendEmail) SendMail(OrderSymbol()+"Add-On",OrderSymbol()+" has given an add-on SELL signal for an existing position.");
                  if(DisplayAlert) Alert(OrderSymbol()+"Add-On :: "+OrderSymbol()+" has given an add-on SELL signal for an existing position.");
               }             
             
             }//if(OrderTakeProfit() > PositiveMoveInPips)
         }//if(OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY) == true) continue;
       }//for(int cnt = 0; cnt < OrdersTotal(); cnt++)
   FuncLastRunTime2 = TimeCurrent();
   }//if(FuncLastRunTime + (TimeElapsed*60) < TimeCurrent())
}

void Printtxt(string text, string str,int size, string font, color vcolor, double vertical, double horizontal) 
{
   //if (ObjectFind(str) != 0)
   if (ObjectFind(str) == -1)
   {
      ObjectCreate(str, OBJ_LABEL, 0, 0, 0);      
   }
   ObjectSetText(str, text, size, font, vcolor);
   ObjectSet(str, OBJPROP_XDISTANCE, 0 + horizontal);
   ObjectSet(str, OBJPROP_YDISTANCE, 0 + 14.0 * vertical);
}//End void Printtxt(string text, string str,int size, string font, color vcolor = -1, double vertical = -1.0, int horizontal = 0) {

