//+------------------------------------------------------------------+
//|                                            vj_HA T3-1_Arrows.mq4 |
//|                                   Copyright  2010, Varun Juneja |
//|                                  http://www.myforexjourney.co.cc |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Varun Juneja"
#property link      "http://www.myforexjourney.co.cc"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 DarkOliveGreen
#property indicator_color2 Maroon
#property indicator_color3 DarkOliveGreen
#property indicator_color4 Maroon
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2

double CrossUp[];
double CrossDown[];
double BuyExit[];
double SellExit[];


//plot state can be 1 of: UP,DOWN
#define PLOTUP 1
#define PLOTDOWN -1
int iWaitFor = PLOTDOWN;  //initial value



//+------------------------------------------------------------------+
//| Custom indicator initialization function |
//+------------------------------------------------------------------+
int init()
{
  //---- indicators
  SetIndexStyle(0, DRAW_ARROW, EMPTY);
  SetIndexArrow(0, 233);
  SetIndexBuffer(0, CrossUp);
  SetIndexStyle(1, DRAW_ARROW, EMPTY);
  SetIndexArrow(1, 234);
  SetIndexBuffer(1, CrossDown);
  SetIndexStyle(2, DRAW_ARROW, EMPTY);
  SetIndexArrow(2, 217);
  SetIndexBuffer(2, BuyExit);
  SetIndexStyle(3, DRAW_ARROW, EMPTY);
  SetIndexArrow(3, 218);
  SetIndexBuffer(3, SellExit);

  return(0);
}
//+------------------------------------------------------------------+
//| script program start function |
//+------------------------------------------------------------------+
int start()
{ 
  
  int counted_bars = IndicatorCounted();
  int i;
  int limit;
  if(counted_bars < 0) 
  return(-1);
  if(counted_bars > 0) 
  counted_bars--;
  limit = Bars - counted_bars;
  
  int waitingfor;
  
  //for(int j = 0; j<30; j++){
  
  for(i=limit; i>0; i--)
  {
      
   double arrowup = iCustom(Symbol(),0,"Heiken_Ashi_Ma_T3-1",4,i+1);
   double arrowdown = iCustom(Symbol(),0,"Heiken_Ashi_Ma_T3-1",5,i+1);
   
   double AO_Curr = iMA(Symbol(),0,5,0,MODE_SMA,PRICE_MEDIAN,i)-iMA(Symbol(),0,34,0,MODE_SMA,PRICE_MEDIAN,i);
   double AO_Prev = iMA(Symbol(),0,5,0,MODE_SMA,PRICE_MEDIAN,i+1)-iMA(Symbol(),0,34,0,MODE_SMA,PRICE_MEDIAN,i+1);
   
   double TrendLordBlue = iCustom(Symbol(),0,"TrendLord",1,i);
   double TrendLordRed = iCustom(Symbol(),0,"TrendLord",2,i);
    
     
    if (arrowup < 5000 && AO_Curr > 0 && AO_Curr > AO_Prev && TrendLordBlue < 5000 && iWaitFor == PLOTUP) // Condition for Buy  
    {
      iWaitFor = PLOTDOWN;
      waitingfor = 1;
      CrossUp[i]=iLow(Symbol(),0,i) - 30*Point; 
    } else {
      if(arrowup < 5000 && waitingfor == 0)
      {
         BuyExit[i]=iLow(Symbol(),0,i) - 30*Point; 
      }
    }    
    
         
    if (arrowdown < 5000 && AO_Curr < 0 && AO_Curr < AO_Prev && TrendLordRed < 5000 && iWaitFor == PLOTDOWN) // Condition for Sell 
    {
      iWaitFor = PLOTUP;
      waitingfor = 0;
      CrossDown[i]=iHigh(Symbol(),0,i) + 30*Point; 
    } else {
      if(arrowdown < 5000 && waitingfor == 1)
      {
         SellExit[i]=iHigh(Symbol(),0,i) + 30*Point; 
      }
    }    
    
  }
  return(0);
}

